%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%% CONTROLLO DUPLICATI E RECIPROCI %%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

% PARTE 1: INPUT E RIORDINAMENTO QUADRIPOLI %
%%% chiede se ci sono file da unire e quanti sono
%%% elimina inoltre i dati con V troppo bassa.

clear
close all

sogliaVp=0.001; % soglia sotto cui eliminare il potenziale
perc_err=0.05;     % percentuale errore da media su [0 1]

% innanzi tutto chiede se ci sono linee da unire
domandalinee=input('ci sono pi? linee da unire? (y/n)  ','s');
caso1=strcmp(domandalinee,'y') | strcmp(domandalinee,'Y');

if caso1==1;
  num_profili=input('quanti sono i profili da unire?  ');
else
  num_profili=1;
end

% carica i file
elecs=[];
res=[];
nt=0;

for u=1:num_profili
     fname=input('nome del file txt da siscal:  ','s');
     filename=[fname,'.txt'];
     primo=input ('il profilo parte dall''elettrodo numero:  ');
     ndf=input('nel file testo il primo elettrodo ? il numero:   ');
     elplus=primo-ndf;

     fid=fopen(filename);
     C = textscan(fid,'%f %f %f %f %f %f %f %f %f %f','headerlines',1);
     fclose(fid);

     elecs_pre=[C{1}+elplus, C{2}+elplus, C{3}+elplus, C{4}+elplus];      % estrae la matrice con i soli quadripoli
     V=C{9};
     I=C{10};
     
     nt=nt+size(elecs_pre,1);
     iid=find(abs(V)>sogliaVp);
     elecs=[elecs;elecs_pre(iid,:)];
     res=[res;V(iid)./I(iid)];
     
end

    iid=find(res<0);
    res(iid)=abs(res(iid));
    elecs(iid,:)=elecs(iid,[1 2 4 3]);
 
% controllo per elettrodi da togliere
fprintf('\n')
fprintf('elenco elettrodi presenti:\n')
fprintf('%d\t',unique(elecs))
fprintf('\n')

eel=input('elettrodi da eliminare:   ');
if ~isempty(eel)
    for ii=1:numel(eel)
        [ider,idec]=find(sum(elecs~=eel(ii),2)==4);
        res=res(ider);
        elecs=elecs(ider,:);
    end
fprintf('\n')
fprintf('elenco elettrodi rimasti:\n')
fprintf('%d\t',unique(elecs))
fprintf('\n')
end

clear C V I elecs_pre fid iid ndf elplus primo eel ider ides;


%% PARTE 2: CONTROLLO RECIPROCI + DUPLICATI %
%%% fa un controllo sui reciproci e duplicati con dev std del 5%
%%% restituisce il file 'protocol.dat'

hw = waitbar(0,'Checking duplicates and reciprocals...');

n=size(elecs,1);
profiler_rec=[];
stdrec=[];
list=[];
ok=0;
scartati=0;
norec=0;
npol=0;
dupli=0;
npold=0;
rec=0;

if exist('report_reciproci.txt','file')==2
    delete('report_reciproci.txt')
end
nomefile=fopen('report_reciproci.txt', 'a');

for ii=1:n
    
    contrrec=0;
    contrdup=0;
    
 if sum(ii==list)==0

     waitbar(ii/n);
     
   list=[list;ii];
   ind=find(sum(ismember(elecs,elecs(ii,:)),2)==4);
   
   if size(ind,1)>1
       ind2=ii;
       inddup=[];
        for  jj=1:size(ind,1)
          if  sum(ind(jj)==list)==0 
           if isequal(elecs(ii,:),elecs(ind(jj),[3 4 1 2])) ||...
                   isequal(elecs(ii,:),elecs(ind(jj),[4 3 2 1]))
                ind2=[ind2;ind(jj)];
                list=[list;ind(jj)];
                contrrec=contrrec+1;
            elseif isequal(elecs(ii,:),elecs(ind(jj),[2 1 4 3])) ||...
                   isequal(elecs(ii,:),elecs(ind(jj),[1 2 3 4]))
                inddup=[inddup;ind(jj)];
                list=[list;ind(jj)];
                contrdup=contrdup+1;
            elseif isequal(elecs(ii,:),elecs(ind(jj),[3 4 2 1])) ||...
                   isequal(elecs(ii,:),elecs(ind(jj),[4 3 1 2]))
                npol=npol+1;
                fprintf(nomefile,'  A\t   B\t   M\t   N\t Res(Ohm)\n'); 
                fprintf(nomefile,'%3.f\t %3.f\t %3.f\t %3.f\t %3.7f\t', [elecs(ii,:),res(ii)]');
                fprintf(nomefile,'quad rif!\n');
                fprintf(nomefile,'%3.f\t %3.f\t %3.f\t %3.f\t %3.7f\n', [elecs(ind(jj),:),res(ind(jj))]');
                fprintf(nomefile,'PROBLEMA POLARITA'' RECIPROCO!\n');
                fprintf(nomefile,'\r');
                list=[list;ind(jj)];
                contrrec=contrrec+1;
            elseif isequal(elecs(ii,:),elecs(ind(jj),[1 2 4 3])) ||...
                   isequal(elecs(ii,:),elecs(ind(jj),[2 1 3 4]))
                npold=npold+1;
                fprintf(nomefile,'  A\t   B\t   M\t   N\t Res(Ohm)\n'); 
                fprintf(nomefile,'%3.f\t %3.f\t %3.f\t %3.f\t %3.7f\t', [elecs(ii,:),res(ii)]');
                fprintf(nomefile,'quad rif!\n');
                fprintf(nomefile,'%3.f\t %3.f\t %3.f\t %3.f\t %3.7f\n', [elecs(ind(jj),:),res(ind(jj))]');
                fprintf(nomefile,'PROBLEMA POLARITA'' DUPLICATO!\n');
                fprintf(nomefile,'\r');
                list=[list;ind(jj)];
                contrdup=contrdup+1;
           end
          end
       end
        
        if size(ind2,1)>1
            ind=[ind2;inddup];
            rec=rec+size(ind2,1);
            dupli=dupli+size(inddup,1);
        elseif size(ind2,1)==1 & contrdup>0 & contrrec==0
             ind=[];
             dupli=dupli+size(inddup,1);
                fprintf(nomefile,'  A\t   B\t   M\t   N\t Res(Ohm)\n'); 
                fprintf(nomefile,'%3.f\t %3.f\t %3.f\t %3.f\t %3.7f\t', [elecs(ii,:),res(ii)]');
                fprintf(nomefile,'quad rif!\n');
                fprintf(nomefile,'HA DUPLICATI MA NON RECIPROCI!\n');
                fprintf(nomefile,'\r');
        elseif size(ind2,1)==1 & contrdup==0 & contrrec==0
             ind=[];
             norec=norec+1;
                 fprintf(nomefile,'  A\t   B\t   M\t   N\t Res(Ohm)\n'); 
                 fprintf(nomefile,'%3.f\t %3.f\t %3.f\t %3.f\t %3.7f\n', [elecs(ii,:),res(ii)]');
                 fprintf(nomefile,'NO RECIPROCI!!\n');
                 fprintf(nomefile,'\r');
        else
            ind=[];
        end
   else
         norec=norec+1;
         fprintf(nomefile,'  A\t   B\t   M\t   N\t Res(Ohm)\n'); 
         fprintf(nomefile,'%3.f\t %3.f\t %3.f\t %3.f\t %3.7f\n', [elecs(ii,:),res(ii)]');
         fprintf(nomefile,'NO RECIPROCI!!\n');
         fprintf(nomefile,'\r');            
   end
        
   if size(ind,1)>1
       elenco_res=res(ind);
       media_res=mean(elenco_res);
       if numel(elenco_res)==2
         perc_errore_da_media = abs(elenco_res(1)-elenco_res(2))/media_res; % Relative Standard Deviation
       else
         perc_errore_da_media = std(elenco_res,0)/media_res; % Relative Standard Deviation
       end
       if perc_errore_da_media<perc_err
           profiler_rec=[profiler_rec;elecs(ii,:),media_res];
           stdrec=[stdrec;std(elenco_res,0)];
           ok=ok+1;
              fprintf(nomefile,'  A\t   B\t   M\t   N\t Res(Ohm)\n'); 
              fprintf(nomefile,'%3.f\t %3.f\t %3.f\t %3.f\t %3.7f\n', [elecs(ind,:),elenco_res]');
              fprintf(nomefile,'res media(Ohm)\t');
              fprintf(nomefile,'%3.7f\n', media_res);
              fprintf(nomefile,['errore da media(<',num2str(perc_err),')\t']);
              fprintf(nomefile,'%3.7f\n',perc_errore_da_media);
              fprintf(nomefile,'OK!\n');
              fprintf(nomefile,'\r');
       elseif perc_errore_da_media>=perc_err
              scartati=scartati+1;
              fprintf(nomefile,'  A\t   B\t   M\t   N\t Res(Ohm)\n'); 
              fprintf(nomefile,'%3.f\t %3.f\t %3.f\t %3.f\t %3.7f\n', [elecs(ind,:),elenco_res]');
              fprintf(nomefile,'res media(Ohm)\t');
              fprintf(nomefile,'%3.7f\n', media_res);
              fprintf(nomefile,['errore da media(>',num2str(perc_err),')\t']);
              fprintf(nomefile,'%3.7f\n',perc_errore_da_media);
              fprintf(nomefile,'SCARTATO!\n');
              fprintf(nomefile,'\r');
       end
   end
 end
end

    perc_scar=scartati/(ok+scartati)*100;
    perc_rec=rec/n*100;
    perc_ok=ok/(ok+scartati)*100;
    perc_norec=norec/n*100;
    perc_vsoglia=(nt-n)/nt*100;
    perc_npol=npol/n*100;
    perc_npold=npold/n*100;
    perc_dupli=dupli/n*100;
    perc_probl=(n-rec-norec)/n*100;
    
   fprintf(nomefile,'\n');
   fprintf(nomefile,'RIEPILOGO\n');
   fprintf(nomefile,'\n');
   fprintf(nomefile,'su un totale di ');   fprintf(nomefile,'%3.f\t', nt);   fprintf(nomefile,'misure:\n');
   fprintf(nomefile,'misure con V>');   fprintf(nomefile,'%10.9f\t', sogliaVp); fprintf(nomefile,': '); fprintf(nomefile,'%3.f\t', nt-n); fprintf(nomefile,'%4.2f', perc_vsoglia); fprintf(nomefile,'%%\n');
   fprintf(nomefile,'\n');
   fprintf(nomefile,'su un totale di ');   fprintf(nomefile,'%3.f\t', n);   fprintf(nomefile,'misure V sopra soglia:\n');
   fprintf(nomefile,'reciproci con polarit? giusta: ');   fprintf(nomefile,'%3.f\t', rec); fprintf(nomefile,'%4.2f', perc_rec); fprintf(nomefile,'%%\n');
   fprintf(nomefile,'misure senza reciproco: ');   fprintf(nomefile,'%3.f\t', norec); fprintf(nomefile,'%4.2f', perc_norec); fprintf(nomefile,'%%\n');
   fprintf(nomefile,'misure con solo duplicati o problemi polarit?: ');   fprintf(nomefile,'%3.f\t', [n-rec-norec]); fprintf(nomefile,'%4.2f', perc_probl); fprintf(nomefile,'%%\n');
   fprintf(nomefile,'\n');
   fprintf(nomefile,'su un totale di ');   fprintf(nomefile,'%3.f\t', ok+scartati);   fprintf(nomefile,'misure con reciproco giusto:\n');
   fprintf(nomefile,'misure salvate: ');   fprintf(nomefile,'%3.f\t', ok);  fprintf(nomefile,'%4.2f', perc_ok); fprintf(nomefile,'%%\n');
   fprintf(nomefile,'misure scartate: ');   fprintf(nomefile,'%3.f\t', scartati); fprintf(nomefile,'%4.2f', perc_scar); fprintf(nomefile,'%%\n');
   fprintf(nomefile,'\r');
   if scartati+ok==0
      fprintf(nomefile,'NON ESISTONO RECIPROCI: MA CHE CAZZO DI MISURE STAI FACENDO??\n');
      fprintf(nomefile,'Spero tu stia aggregando pi? profili!!\n');
      fprintf(nomefile,'\r');
   end
   
fclose(nomefile);
close(hw)         

% diagrammi a torta
if nt-n==0 & nt~=rec+norec & norec~=0
    h1=figure(1);
    set(h1,'position',[1 1 1050 600]);
    pietot=[rec, norec, nt-(nt-n)-rec-norec];
    explode=[1 0 0];
    hp=pie(pietot,explode);
    textObjs = findobj(hp,'Type','text');
    oldStr = get(textObjs,{'String'});
    val = get(textObjs,{'Extent'});
    oldExt = cat(1,val{:});
    srec=num2str(rec);
    snorec=num2str(norec);
    sprobl=num2str(nt-(nt-n)-rec-norec);
    Names = {['reciproci: ',srec,' - '];['no reciproci: ',snorec,' - '];['solo duplicati o problemi polarit?: ',sprobl,' - ']};
    newStr = strcat(Names,oldStr);
    set(textObjs,{'String'},newStr)
    val1 = get(textObjs, {'Extent'});
    newExt = cat(1, val1{:});
    offset = sign(oldExt(:,1)).*(newExt(:,3)-oldExt(:,3))/2;
    pos = get(textObjs, {'Position'});
    textPos =  cat(1, pos{:});
    textPos(:,1) = textPos(:,1)+offset;
    set(textObjs,{'Position'},num2cell(textPos,[3,2]))
elseif nt-n==0 & nt~=rec+norec & norec==0
    h1=figure(1);
    set(h1,'position',[1 1 1050 600]);
    pietot=[rec, nt-(nt-n)-rec-norec];
    explode=[1 0];
    hp=pie(pietot,explode);
    textObjs = findobj(hp,'Type','text');
    oldStr = get(textObjs,{'String'});
    val = get(textObjs,{'Extent'});
    oldExt = cat(1,val{:});
    srec=num2str(rec);
    sprobl=num2str(nt-(nt-n)-rec-norec);
    Names = {['reciproci: ',srec,' - '];['solo duplicati o problemi polarit?: ',sprobl,' - ']};
    newStr = strcat(Names,oldStr);
    set(textObjs,{'String'},newStr)
    val1 = get(textObjs, {'Extent'});
    newExt = cat(1, val1{:});
    offset = sign(oldExt(:,1)).*(newExt(:,3)-oldExt(:,3))/2;
    pos = get(textObjs, {'Position'});
    textPos =  cat(1, pos{:});
    textPos(:,1) = textPos(:,1)+offset;
    set(textObjs,{'Position'},num2cell(textPos,[3,2]))
elseif nt-n==0 & nt==rec+norec
    h1=figure(1);
    set(h1,'position',[1 1 1050 600]);
    pietot=[rec, norec];
    explode=[1 0 ];
    hp=pie(pietot,explode);
    textObjs = findobj(hp,'Type','text');
    oldStr = get(textObjs,{'String'});
    val = get(textObjs,{'Extent'});
    oldExt = cat(1,val{:});
    srec=num2str(rec);
    snorec=num2str(norec);
    sprobl=num2str(nt-(nt-n)-rec-norec);
    Names = {['reciproci: ',srec,' - '];['no reciproci: ',snorec,' - ']};
    newStr = strcat(Names,oldStr);
    set(textObjs,{'String'},newStr)
    val1 = get(textObjs, {'Extent'});
    newExt = cat(1, val1{:});
    offset = sign(oldExt(:,1)).*(newExt(:,3)-oldExt(:,3))/2;
    pos = get(textObjs, {'Position'});
    textPos =  cat(1, pos{:});
    textPos(:,1) = textPos(:,1)+offset;
    set(textObjs,{'Position'},num2cell(textPos,[3,2]))
elseif nt-n~=0 & norec==0 & nt-(nt-n)-rec-norec==0
    h1=figure(1);
    set(h1,'position',[1 1 1050 600]);
    pietot=[nt-n, rec];
    explode=[0 1];
    hp=pie(pietot,explode);
    textObjs = findobj(hp,'Type','text');
    oldStr = get(textObjs,{'String'});
    val = get(textObjs,{'Extent'});
    oldExt = cat(1,val{:});
    srec=num2str(rec);
    sVsoglia=num2str(nt-n);
    Names = {['V sotto soglia: ',sVsoglia,' - '];['reciproci: ',srec,' - ']};
    newStr = strcat(Names,oldStr);
    set(textObjs,{'String'},newStr)
    val1 = get(textObjs, {'Extent'});
    newExt = cat(1, val1{:});
    offset = sign(oldExt(:,1)).*(newExt(:,3)-oldExt(:,3))/2;
    pos = get(textObjs, {'Position'});
    textPos =  cat(1, pos{:});
    textPos(:,1) = textPos(:,1)+offset;
    set(textObjs,{'Position'},num2cell(textPos,[3,2]))
elseif nt-n~=0 & norec==0
    h1=figure(1);
    set(h1,'position',[1 1 1050 600]);
    pietot=[nt-n, rec, nt-(nt-n)-rec-norec];
    explode=[0 1 0];
    hp=pie(pietot,explode);
    textObjs = findobj(hp,'Type','text');
    oldStr = get(textObjs,{'String'});
    val = get(textObjs,{'Extent'});
    oldExt = cat(1,val{:});
    srec=num2str(rec);
    sprobl=num2str(nt-(nt-n)-rec-norec);
    sVsoglia=num2str(nt-n);
    Names = {['V sotto soglia: ',sVsoglia,' - '];['reciproci: ',srec,' - '];['solo duplicati o problemi polarit?: ',sprobl,' - ']};
    newStr = strcat(Names,oldStr);
    set(textObjs,{'String'},newStr)
    val1 = get(textObjs, {'Extent'});
    newExt = cat(1, val1{:});
    offset = sign(oldExt(:,1)).*(newExt(:,3)-oldExt(:,3))/2;
    pos = get(textObjs, {'Position'});
    textPos =  cat(1, pos{:});
    textPos(:,1) = textPos(:,1)+offset;
    set(textObjs,{'Position'},num2cell(textPos,[3,2]))
elseif nt-n~=0 & norec~=0 & nt-(nt-n)-rec-norec==0
    h1=figure(1);
    set(h1,'position',[1 1 1050 600]);
    pietot=[nt-n, rec, norec];
    explode=[0 1 0];
    hp=pie(pietot,explode);
    textObjs = findobj(hp,'Type','text');
    oldStr = get(textObjs,{'String'});
    val = get(textObjs,{'Extent'});
    oldExt = cat(1,val{:});
    srec=num2str(rec);
    snorec=num2str(norec);
    sprobl=num2str(nt-(nt-n)-rec-norec);
    sVsoglia=num2str(nt-n);
    Names = {['V sotto soglia: ',sVsoglia,' - '];['reciproci: ',srec,' - '];['no reciproci: ',snorec,' - ']};
    newStr = strcat(Names,oldStr);
    set(textObjs,{'String'},newStr)
    val1 = get(textObjs, {'Extent'});
    newExt = cat(1, val1{:});
    offset = sign(oldExt(:,1)).*(newExt(:,3)-oldExt(:,3))/2;
    pos = get(textObjs, {'Position'});
    textPos =  cat(1, pos{:});
    textPos(:,1) = textPos(:,1)+offset;
    set(textObjs,{'Position'},num2cell(textPos,[3,2]))
else
    h1=figure(1);
    set(h1,'position',[1 1 1050 600]);
    pietot=[nt-n, rec, norec, nt-(nt-n)-rec-norec];
    explode=[0 1 0 0];
    hp=pie(pietot,explode);
    textObjs = findobj(hp,'Type','text');
    oldStr = get(textObjs,{'String'});
    val = get(textObjs,{'Extent'});
    oldExt = cat(1,val{:});
    srec=num2str(rec);
    snorec=num2str(norec);
    sprobl=num2str(nt-(nt-n)-rec-norec);
    sVsoglia=num2str(nt-n);
    Names = {['V sotto soglia: ',sVsoglia,' - '];['reciproci: ',srec,' - '];['no reciproci: ',snorec,' - '];['solo duplicati o problemi polarit?: ',sprobl,' - ']};
    newStr = strcat(Names,oldStr);
    set(textObjs,{'String'},newStr)
    val1 = get(textObjs, {'Extent'});
    newExt = cat(1, val1{:});
    offset = sign(oldExt(:,1)).*(newExt(:,3)-oldExt(:,3))/2;
    pos = get(textObjs, {'Position'});
    textPos =  cat(1, pos{:});
    textPos(:,1) = textPos(:,1)+offset;
    set(textObjs,{'Position'},num2cell(textPos,[3,2]))
end
s_pietotf=[fname '_piechart_tot.fig'];
s_pietote=[fname '_piechart_tot.emf'];
%saveas(h1,s_pietotf);
%saveas(h1,s_pietote);


if scartati==0
    h2=figure(2);
    set(h2,'position',[1 1 1050 600]);
    pierec=[ok];
    hp=pie(pierec);
    colormap jet
    textObjs = findobj(hp,'Type','text');
    oldStr = get(textObjs,{'String'});
    val = get(textObjs,{'Extent'});
    oldExt = cat(1,val{:});
    sok=num2str(ok);
    sscartati=num2str(scartati);
    Names = {['reciproci salvati: ',sok,' - ']};
    newStr = strcat(Names,oldStr);
    set(textObjs,{'String'},newStr)
    val1 = get(textObjs, {'Extent'});
    newExt = cat(1, val1{:});
    offset = sign(oldExt(:,1)).*(newExt(:,3)-oldExt(:,3))/2;
    pos = get(textObjs, {'Position'});
    textPos =  cat(1, pos{:});
    textPos(:,1) = textPos(:,1)+offset;
    set(textObjs,{'Position'},num2cell(textPos,[3,2]))
else
    h2=figure(2);
    set(h2,'position',[1 1 1050 600]);
    pierec=[ok, scartati];
    explode=[1 0];
    hp=pie(pierec,explode);
    colormap jet
    textObjs = findobj(hp,'Type','text');
    oldStr = get(textObjs,{'String'});
    val = get(textObjs,{'Extent'});
    oldExt = cat(1,val{:});
    sok=num2str(ok);
    sscartati=num2str(scartati);
    Names = {['reciproci salvati: ',sok,' - '];['reciproci scartati: ',sscartati,' - ']};
    newStr = strcat(Names,oldStr);
    set(textObjs,{'String'},newStr)
    val1 = get(textObjs, {'Extent'});
    newExt = cat(1, val1{:});
    offset = sign(oldExt(:,1)).*(newExt(:,3)-oldExt(:,3))/2;
    pos = get(textObjs, {'Position'});
    textPos =  cat(1, pos{:});
    textPos(:,1) = textPos(:,1)+offset;
    set(textObjs,{'Position'},num2cell(textPos,[3,2]))
end
s_pierecf=[fname '_piechart_rec.fig'];
s_pierece=[fname '_piechart_rec.emf'];
%saveas(h2,s_pierecf);
%saveas(h2,s_pierece);

%% SALVATAGGIO FILE X PROFILER%
nsalvati=size(profiler_rec,1);
elenco_misure=[1:nsalvati]';
protocol=[elenco_misure,profiler_rec]';
nomefile=fopen('protocol.dat', 'wt');
fprintf(nomefile,'%5.f\n',nsalvati);
fprintf(nomefile,'%3.f\t %3.f\t %3.f\t %3.f\t %3.f\t %1.9E\n',protocol);
fclose(nomefile);

%% CREAZIONE REGRESSIONE ERRORE
% excel per misura errore di reciproci salvati
errfile=[profiler_rec,stdrec];
s_res=[fname '_err'];
xlswrite(s_res,{'A','B','M','N','res [ohm]','std err [ohm]'});
xlswrite(s_res,errfile,'Foglio1','A2');
% scatterplot errore-res
h3=figure(3);
hold on
scatter(profiler_rec(:,5),stdrec,'.k');
xlabel('resistance [\Omega]');
ylabel('\sigma error [\Omega]');
limres=[0,max(profiler_rec(:,5))];
lincoef=polyfit(profiler_rec(:,5),stdrec,1);
linlim=polyval(lincoef,limres);
lin5perc=[perc_err,lincoef(1,2)];
linea5perc=polyval(lin5perc,limres);
plot(limres,linlim,'-b');
plot(limres,linea5perc,'-r');
ss=(['a=', num2str(lincoef(1,2))]);
ss2=(['b=',num2str(lincoef(1,1))]);
annotation(h3,'textbox',[0.15 0.85 0.01 0.01],...
            'VerticalAlignment','middle',...
            'String',{ss,ss2},...
            'HorizontalAlignment','left',...
            'FitBoxToText','on',...
            'edgecolor','b');
ss=(['a=', num2str(lin5perc(1,2))]);
ss2=(['b=',num2str(lin5perc(1,1))]);
annotation(h3,'textbox',[0.15 0.70 0.01 0.01],...
            'VerticalAlignment','middle',...
            'String',{ss,ss2},...
            'HorizontalAlignment','left',...
            'FitBoxToText','on',...
            'edgecolor','r');
title('ERROR SCATTER')
s_err=[fname '_trend_err.emf'];
%saveas(h3,s_err);
hold off


%% CREAZIONE IMMAGINE DI RESISTIVITA' APPARENTE: PSEUDOSEZIONE %%%

dompseudo=input('Vuoi l''immagine di pseudosezione? (y/n)   ','s');
caso1pse=strcmp(dompseudo,'y') | strcmp(dompseudo,'Y');

if caso1pse==1
    domdip=input('? una sequenza dip-dip? (y/n)   ','s');
    caso1dip=strcmp(domdip,'y') | strcmp(domdip,'Y');
    sx=input('Spaziatura fra gli elettrodi [m]:   ');
    quadr=profiler_rec(:,1:4);
    resps=profiler_rec(:,5);
    quadm=(quadr-1)*sx;
    
    elapp=[];
    xpre=[];
    zpre=[];
    for q=1:nsalvati
        am=abs(quadm(q,1)-quadm(q,3));
        an=abs(quadm(q,2)-quadm(q,3));
        bm=abs(quadm(q,1)-quadm(q,4));
        bn=abs(quadm(q,2)-quadm(q,4));
        K=(2*(pi))/((1/am)-(1/an)-(1/bm)+(1/bn));
        rhoapp=K*resps(q);
        elapp=[elapp;rhoapp];
        if caso1dip==1          
            ordrow=sort(quadm(q,:));
            xpre=[xpre;(ordrow(2)+ordrow(3))/2];
            zpre=[zpre;abs((abs(ordrow(2)-ordrow(3)))*sin(60))]; 
        else
            ordrow2=sort(quadm(q,:));
            ratio=(abs(ordrow2(1)-ordrow2(2)))/(abs(ordrow2(2)-ordrow2(3)));
            xpre=[xpre;(ordrow2(2)+ordrow2(3))/2];
            zpre=[zpre;(abs(ordrow2(2)-ordrow2(3)))*ratio];
        end
    end
  
    h4=figure(4);
    scatter(xpre,-zpre,3,elapp,'filled');       
    % mycmap = get(1,'Colormap')
    % save('MyColormaps','mycmap')
%     load('MyColormaps','mycmap');
%     set(1,'Colormap',mycmap);
    colorbar
    tname=[fname ' - resistivit? apparente [ohm*m]'];
    title(tname);
%     caxis([0 1e4])
    saveas(h4,[fname '_RHOapp.emf']);
    saveas(h4,[fname '_RHOapp.fig']);
    
    h5=figure;
    scatter(xpre,-zpre,3,resps,'filled');       
    % mycmap = get(1,'Colormap')
    % save('MyColormaps','mycmap')
%     load('MyColormaps','mycmap');
%     set(1,'Colormap',mycmap);
    colorbar
    tname=[fname ' - resistenza [ohm]'];
    title(tname);
%     caxis([0 3])
    saveas(h5,[fname '_RES.emf']);
    saveas(h5,[fname '_RES.fig'])

end


